
!Simple sampling scheme for the 2D Ising model
! by D.Jost 08/09/09

program mainising

implicit none

include 'global.var' !include global variables

real*8,allocatable		::D(:,:) !density of state
real*8		::M !current magnetization
real*8		::NNC !current nearest-neighbour coupling

real*8		::tmm,randomnumber !other local variables
integer		::time,i,j !other local variables

!initialize random number generator
call SYSTEM_CLOCK(time)
tmm=real(time)
tmm=tmm/(10d0**(real(int(dlog(tmm)/dlog(10d0)))))
call initializerandomnumbergenerator(tmm)

!open the input file
open(10,file='input.dat')
read(10,*) P !size of the spin matrix
read(10,*) NumberConfig !number of generated configurations
read(10,*) TempMin !minimal scanned temperature
read(10,*) TempMax !maximal scanned temperature
read(10,*) dTemp !temperature interval
close(10)

N=P*P

!initialize the density of state D
allocate(D(N+1,N+1)) 
D=0d0

do i=1,NumberConfig
	!generate a random configuration and compute M and NNC
	call randomconfig(M,NNC)
	
	!update the density of state
	D(!*************!)=D(!*************!)+1d0
	
end do

!save the normalized density of state
open(11,file='NormDensState.out')
do i=1,N+1
	write(11,*) (D(i,j)/real(NumberConfig),j=1,N+1)
end do
close(11)
!compute the rms magnetization from TempMin to TempMax

call rmsm(D)

end program mainising