
!compute pi 
! by D.Jost 08/09/09

program mainpi

implicit none

real*8		:: l !length of the square
real*8		:: d !circle diameter
real*8		:: ratio !ratio l/d
integer		:: NumberCycles !number of generated coordinates

real*8		::Hits !number of random coordinates in the circle
real*8		::Pi !estimated value of pi

real*8		::tmm,randomnumber,x,y !other local variables
integer		::time,i !other local variables

!initialize random number generator
call SYSTEM_CLOCK(time)
tmm=real(time)
tmm=tmm/(10d0**(real(int(dlog(tmm)/dlog(10d0)))))
call initializerandomnumbergenerator(tmm)

!open the input file
open(10,file='input.dat')
read(10,*) ratio
read(10,*) NumberCycles
close(10)

d=1d0
l=ratio*d

Hits=0d0

do i=1,NumberCycles
	! pick a random coordinate in the square [-l/2,l/2]x[-l/2,l/2]
	x=!**************!
	y=!**************!
	
	!chech if the coordinate is in the circle
	if (dsqrt(x*x+y*y).lt.(d/2d0)) Hits=Hits+1d0

end do

!compute Pi
Pi=!**************!

!print results
write(*,*) 'Ratio:',ratio
write(*,*) 'Number of cycles:', NumberCycles
write(*,*) 'Pi(estimated):',Pi
write(*,*) '|Pi(estimated)-Pi(exact)|:',abs(Pi-4d0*datan(1d0))


end program mainpi