!generate a random chain and compute Re
! by D.Jost 08/08/09

subroutine randomchain(Hits,Re2)

implicit none

include 'global.var'

real*8,dimension(NchainMax)		::Hits,Re2 !the number of succeded growing chains and the average end-to-end squared distance
integer,dimension(NchainMax+1,3)	::chain !the bead position
integer,dimension(3)		::site !current bead position
real*8,dimension(Nbmax,4)			::htable !the hash table
real*8							::r2 !the end-to-end distance

integer		::h,error,oc,p,next,randNN
real*8		::randomnumber
!initialize variables

chain=0d0
htable=0

!put the first monomer
h=0
htable(h+1,1)=1

next=2
error=0

! we place all the monomers until then entire chain is growth or until we find a occupied site (error=1)
do while ((next.le.(NchainMax+1)).and.(error.eq.0))
	!choose randomly among the 6 neighbours
	randNN=int(6*randomnumber())+1
	
	select case(randNN)
		case(1)
			site(1)=chain(next-1,1)+1
			site(2)=chain(next-1,2)
			site(3)=chain(next-1,3)
		case(2)
			site(1)=chain(next-1,1)-1
			site(2)=chain(next-1,2)
			site(3)=chain(next-1,3)
		case(3)
			site(1)=chain(next-1,1)
			site(2)=chain(next-1,2)+1
			site(3)=chain(next-1,3)
		case(4)
			site(1)=chain(next-1,1)
			site(2)=chain(next-1,2)-1
			site(3)=chain(next-1,3)
		case(5)
			site(1)=chain(next-1,1)
			site(2)=chain(next-1,2)
			site(3)=chain(next-1,3)+1
		case(6)
			site(1)=chain(next-1,1)
			site(2)=chain(next-1,2)
			site(3)=chain(next-1,3)-1
	end select
	
	!verify if the site is occupied
	oc=1
	h=mod(mod(a1*site(1)+a2*site(2)+a3*site(3),Nbmax)+Nbmax,Nbmax)
	p=0
	if (htable(h+1,1).eq.0) then!occupation de sitev
        oc=0
	else
		do while ((htable(mod(h+p,Nbmax)+1,1).ne.0).and.((htable(mod(h+p,Nbmax)+1,2).ne.(site(1))) &
				.or.(htable(mod(h+p,Nbmax)+1,3).ne.(site(2))).or.(htable(mod(h+p,Nbmax)+1,4).ne.(site(3))))) 
				p=p+1
		end do
		if (htable(mod(h+p,Nbmax)+1,1).eq.0) oc=0
	end if
	if (oc.eq.0) then !the site is not occupied
		chain(next,:)=site !store the position
		htable(mod(h+p,Nbmax)+1,1)=next
		htable(mod(h+p,Nbmax)+1,2)=chain(next,1)
		htable(mod(h+p,Nbmax)+1,3)=chain(next,2)
		htable(mod(h+p,Nbmax)+1,4)=chain(next,3)
		
		!update Hits
		Hits(!********!)=Hits(!********!)+!********!
		
		!compute Re2
		r2=!********!
		Re2(!********!)=Re2(!********!)+r2
	else
		error=1
	end if
	next=next+1
end do

end subroutine randomchain