!compute the rms magnetization from D 
! by D.Jost 08/09/09

subroutine rmsm(D)

implicit none

include 'global.var'

real*8,dimension(N+1,N+1)		::D !density of state
real*8		::T !current temperature
real*8		::Mag2 !mean squared magnetization
real*8		::rmsMag !normalized rms magnetization
real*8		::norm !normalisation factor
integer		::NumberTemp !number of scanned temperature

integer		::i,j,k
real*8		::M,NNC

NumberTemp=int((TempMax-TempMin)/dTemp)+1

open(11,file='rmsMag.out')

do k=0,NumberTemp-1
	T=TempMin+k*dTemp !current temperature
	
	!initialize Mag2 and the normalisation factor
	Mag2=0d0
	norm=0d0
	do i=1,N+1
		M=2d0*(i-1)-N !corresponding M value
		do j=1,N+1
			NNC=4d0*(j-1)-2d0*N !corresponding NNC value
			Mag2=Mag2+!*************!
			norm=norm+!*************!
		end do
	end do
	!save the normalized rms magnetization
	rmsMag=!*************!
	write(11,*) T,rmsMag
	
end do

close(11)

end subroutine rmsm